#include <sourcemod>
#include <sdktools>
#include <multicolors>
#include <autoexecconfig>
#include <sdkhooks>
#include <cstrike>
#include <adminmenu>

#pragma semicolon 1

#define DEBUG

#pragma newdecls required

//==========================================================================================================
// Thanks to the owners of these plugins
// 
// Admin STEALTH - https://forums.alliedmods.net/showthread.php?p=2499417 - By Potatoz
// Advanced Admin ESP - https://forums.alliedmods.net/showthread.php?p=2476344 - By Mitchell
// Command Hider - https://forums.alliedmods.net/showthread.php?t=274465 - By ZipCore
//==========================================================================================================

//==========================================================================================================
// Agradecimentos aos Donos desses plugins:
// 
// Admin STEALTH - https://forums.alliedmods.net/showthread.php?p=2499417 - By Potatoz
// Advanced Admin ESP - https://forums.alliedmods.net/showthread.php?p=2476344 - By Mitchell
// Command Hider - https://forums.alliedmods.net/showthread.php?t=274465 - By ZipCore
//==========================================================================================================

public Plugin myinfo = 
{
	name = "STAFF Modes - Fake Leave and Join Server", 
	author = "LanteJoula", 
	description = "STAFF Modes - Fake Leave and Join Server for Staff with Chat Message and Wall Hack", 
	version = "1.8", 
	url = "https://steamcommunity.com/id/lantejoula/"
};

ConVar gConVar_Staff_Join;
ConVar gConVar_Staff_Leave;
ConVar gConVar_Join_StaffMode;
ConVar gConVar_Leave_StaffMode;
ConVar gConVar_JoinMsg;

ConVar gConVar_Leave_Message;
ConVar gConVar_Join_Message;

//STEALTH

bool g_bHideMe[MAXPLAYERS + 1] =  { false, ... };

int g_iPlayerManager;
int g_iConnectedOffset;
int g_iAliveOffset;
int g_iTeamOffset;
int g_iPingOffset;
int g_iScoreOffset;
int g_iDeathsOffset;
int g_iHealthOffset;

ConVar sm_stealth_autoswitch;
ConVar sm_stealth_disable_switch;

//ADMIN ESP

#define HEADSCALE 1.0
#define HEADPROP "models/player/holiday/facemasks/facemask_tf2_spy_model.mdl"
#define HEADATTACH "facemask"

#define NORMATTACH "primary"

ConVar cColor[2];
ConVar cLifeState;
ConVar cTeam;
ConVar cModel;

int colors[2][4];

bool isUsingESP[MAXPLAYERS + 1];
bool canSeeESP[MAXPLAYERS + 1];
int playersInESP = 0;
ConVar sv_force_transmit_players;

int playerModels[MAXPLAYERS + 1] =  { INVALID_ENT_REFERENCE, ... };
int playerModelsIndex[MAXPLAYERS + 1] =  { -1, ... };

int playerTeam[MAXPLAYERS + 1] =  { 0, ... };

#define EF_BONEMERGE                (1 << 0)

//ADMIN MENU

Handle hAdminMenu;

//PICKING TEAM MENU

bool PickingMenu[MAXPLAYERS + 1] = false;

//MODES MENU

bool StaffModes[MAXPLAYERS + 1] = true;

public void OnPluginStart()
{
	//ADMIN MEN
	Handle topmenu;
	if (LibraryExists("adminmenu") && ((topmenu = GetAdminTopMenu()) != INVALID_HANDLE))
		OnAdminMenuReady(topmenu);
	
	
	LoadTranslations("staffmodesfakeleavejoin.phrases");
	
	//Open Menu
	RegConsoleCmd("sm_staff", Staff_Mode);
	
	//CONVARS
	AutoExecConfig_SetFile("plugin.staffmodesfakeleavejoin");
	
	gConVar_Staff_Join = AutoExecConfig_CreateConVar("sm_staff_join_message", "1", "Enable/Disable the Fake Join on Server Message (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_Staff_Leave = AutoExecConfig_CreateConVar("sm_staff_leave_message", "1", "Enable/Disable the Fake Leave on Server Message (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_Join_StaffMode = AutoExecConfig_CreateConVar("sm_join_staffmode_message", "1", "Enable/Disable the Join Staff Mode Message (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_Leave_StaffMode = AutoExecConfig_CreateConVar("sm_leave_staffmode_message", "1", "Enable/Disable the Leave Staff Mode Message (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	
	gConVar_Join_Message = AutoExecConfig_CreateConVar("sm_join_message", "1", "Enable/Disable the Message when Players Join/Connect on Server (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	gConVar_Leave_Message = AutoExecConfig_CreateConVar("sm_leave_message", "1", "Enable/Disable the Message when Players Leave/Disconnect on Server (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	
	gConVar_JoinMsg = AutoExecConfig_CreateConVar("z_join_message", "1", "Enable/Disable the Message when STAFF Join (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	
	AutoExecConfig_ExecuteFile();
	AutoExecConfig_CleanFile();
	
	//STEALTH
	HookEvent("player_team", Event_OnPlayerTeam, EventHookMode_Pre);
	
	RegAdminCmd("sm_xlantestealthjoulax", Command_StealthMode, ADMFLAG_GENERIC);
	
	sm_stealth_autoswitch = AutoExecConfig_CreateConVar("sm_stealth_autoswitch", "1", "Automatically switch admins to spectators on Stealth?", FCVAR_DONTRECORD, true, 0.0, true, 1.0);
	sm_stealth_disable_switch = AutoExecConfig_CreateConVar("sm_stealth_disable_switch", "1", "Disable Stealth Mode on switch to other team? (If autoswitch is enabled)", FCVAR_DONTRECORD, true, 0.0, true, 1.0);
	
	g_iConnectedOffset = FindSendPropInfo("CCSPlayerResource", "m_bConnected");
	g_iAliveOffset = FindSendPropInfo("CCSPlayerResource", "m_bAlive");
	g_iTeamOffset = FindSendPropInfo("CCSPlayerResource", "m_iTeam");
	g_iPingOffset = FindSendPropInfo("CCSPlayerResource", "m_iPing");
	g_iScoreOffset = FindSendPropInfo("CCSPlayerResource", "m_iScore");
	g_iDeathsOffset = FindSendPropInfo("CCSPlayerResource", "m_iDeaths");
	g_iHealthOffset = FindSendPropInfo("CCSPlayerResource", "m_iHealth");
	
	//ADMIN ESP
	
	sv_force_transmit_players = FindConVar("sv_force_transmit_players");
	cColor[0] = AutoExecConfig_CreateConVar("sm_advanced_esp_tcolor", "255 1 255", "Determines R G B glow colors for Terrorists team\nFormat should be \"R G B\" (with spaces)", 0);
	cColor[1] = AutoExecConfig_CreateConVar("sm_advanced_esp_ctcolor", "255 1 255", "Determines R G B glow colors for Counter-Terrorists team\nFormat should be \"R G B\" (with spaces)", 0);
	cLifeState = AutoExecConfig_CreateConVar("sm_advanced_esp_lifestate", "1", "Set to 1 if admins should only see esp when dead, 2 to only see esp while alive, 0 dead or alive.", FCVAR_DONTRECORD, true, 0.0, true, 1.0);
	cTeam = AutoExecConfig_CreateConVar("sm_advanced_esp_team", "0", "0 - Display all teams, 1 - Display enemy, 2 - Display teammates", FCVAR_DONTRECORD, true, 0.0, true, 1.0);
	cModel = AutoExecConfig_CreateConVar("sm_advanced_esp_model", "0", "0 - Use current model (full body glow), 1 - Use facemask model on head", FCVAR_DONTRECORD, true, 0.0, true, 1.0);
	cColor[0].AddChangeHook(ConVarChange);
	cColor[1].AddChangeHook(ConVarChange);
	cLifeState.AddChangeHook(ConVarChange);
	cTeam.AddChangeHook(ConVarChange);
	cModel.AddChangeHook(ConVarChange);
	
	for (int i = 0; i <= 1; i++)
	{
		retrieveColorValue(i);
	}
	
	RegAdminCmd("sm_xlanteespwalljoulax", Command_ESP, ADMFLAG_GENERIC);
	
	HookEvent("player_spawn", Event_PlayerSpawn);
	HookEvent("player_death", Event_PlayerDeath);
	HookEvent("round_end", Event_RoundEnd);
	
	//TEAM PICKING
	HookEvent("player_team", Event_OnPlayerTeam1, EventHookMode_Post);
	
	playersInESP = 0;
	
	//COMMAND HIDER
	AddCommandListener(HideCommands, "say");
	AddCommandListener(HideCommands, "say_team");
	
	//JOIN AND LEAVE ANNOUNCER ON CHAT
	HookEvent("player_connect", Event_PlayerConnect5, EventHookMode_Post);
	HookEvent("player_disconnect", Event_PlayerDisconnect5, EventHookMode_Post);
}

//ADMIN MENU

public void OnAllPluginsLoaded()
{
	Handle topmenu;
	if (LibraryExists("adminmenu") && ((topmenu = GetAdminTopMenu()) != null))
		OnAdminMenuReady(topmenu);
}

public void OnAdminMenuReady(Handle topmenu)
{
	if (topmenu == hAdminMenu)
		return;
	
	hAdminMenu = topmenu;
	CreateTimer(1.0, Timer_AttachAdminMenu);
}

public Action Timer_AttachAdminMenu(Handle timer)
{
	TopMenuObject menu_category = AddToTopMenu(hAdminMenu, "staffmodes", TopMenuObject_Category, Handle_Category, INVALID_TOPMENUOBJECT, "staffmodes", ADMFLAG_GENERIC);
	if (menu_category == INVALID_TOPMENUOBJECT)
		return;
	
	AddToTopMenu(hAdminMenu, "sm_staff", TopMenuObject_Item, AdminMenu_StaffMode, menu_category, "sm_staff", ADMFLAG_GENERIC);
}

public void Handle_Category(TopMenu topmenu, TopMenuAction action, TopMenuObject topobj_id, int param, char[] buffer, int maxlength)
{
	if (action == TopMenuAction_DisplayTitle)
		Format(buffer, maxlength, "%T\n ", "Staff Mode Title in Admin", param);
	else if (action == TopMenuAction_DisplayOption)
		Format(buffer, maxlength, "%T\n ", "Staff Mode Title in Admin", param);
}

public void AdminMenu_StaffMode(TopMenu topmenu, TopMenuAction action, TopMenuObject topobj_id, int param, char[] buffer, int maxlength)
{
	if (action == TopMenuAction_DisplayOption)
		Format(buffer, maxlength, "%T", "Staff Mode Buttom in Admin", param);
	else if (action == TopMenuAction_SelectOption)
		ShowMenu(param);
}

//PLUGIN
//PLUGIN
//PLUGIN

public void OnMapStart()
{
	//STEALTH
	g_iPlayerManager = FindEntityByClassname(-1, "cs_player_manager");
	if (g_iPlayerManager != -1)
		SDKHook(g_iPlayerManager, SDKHook_ThinkPost, Hook_PMThink);
	
	//ADMIN ESP
	
	PrecacheModel(HEADPROP);
	resetPlayerVars(0);
}

public void OnClientDisconnect(int client)
{
	//STEALTH
	g_bHideMe[client] = false;
	
	//ADMIN ESP
	resetPlayerVars(client);
}

public void OnClientPutInServer(int client)
{
	//AUTO JOIN MESSAGE
	CreateTimer(5.0, JoinMsg, client);
	
	//ADMIN ESP
	resetPlayerVars(client);
}

///////////////////
//AUTO JOIN MESSAGE
///////////////////

public Action JoinMsg(Handle timer, any client)
{
	if (CheckCommandAccess(client, "sm_override_staff", ADMFLAG_GENERIC))
	{
		if (gConVar_JoinMsg.BoolValue)
			CPrintToChat(client, "%t %t", "Prefix", "JoinMsg");
	}
}

/////////////////
//MODE STAFF MENU
/////////////////

public Action Staff_Mode(int client, int args)
{
	ShowMenu(client);
}

void ShowMenu(int client)
{
	char Fake1[128];
	char JoinCT1[128];
	char JoinT1[128];
	
	Menu menu = new Menu(Menu_Handler);
	menu.SetTitle("%t\n ", "Staff Mode Title");
	if (!StaffModes[client])
	{
		Format(Fake1, sizeof(Fake1), "%t", "Fake");
		menu.AddItem("Fake", Fake1);
	}
	else
	{
		Format(JoinCT1, sizeof(JoinCT1), "%t", "Join CT");
		menu.AddItem("CT", JoinCT1);
		Format(JoinT1, sizeof(JoinT1), "%t", "Join T");
		menu.AddItem("T", JoinT1);
	}
	menu.ExitButton = true;
	menu.Display(client, MENU_TIME_FOREVER);
}

public int Menu_Handler(Menu menu, MenuAction action, int client, int args)
{
	if (action == MenuAction_Select)
	{
		char selectedItem[200];
		menu.GetItem(args, selectedItem, sizeof(selectedItem));
		if (StrEqual(selectedItem, "Fake"))
		{
			if (GetUserFlagBits(client))
			{
				StaffModes[client] = true;
				
				FakeClientCommand(client, "sm_xlantestealthjoulax");
				FakeClientCommand(client, "sm_xlanteespwalljoulax");
				
				char name[128];
				GetClientName(client, name, sizeof(name));
				
				if (gConVar_Staff_Leave.BoolValue)
					CPrintToChatAll("%t", "Leave Message", name);
				if (gConVar_Join_StaffMode.BoolValue)
					CPrintToChat(client, "%t %t", "Prefix", "Join Staff Mode");
				
				PickingMenu[client] = true;
			}
			else
			{
				CPrintToChat(client, "%t %t", "Prefix", "You dont have access");
			}
		}
		if (StrEqual(selectedItem, "CT"))
		{
			if (GetUserFlagBits(client))
			{
				StaffModes[client] = false;
				
				FakeClientCommand(client, "sm_xlanteespwalljoulax");
				
				ChangeClientTeam(client, CS_TEAM_CT);
				
				char name[128];
				GetClientName(client, name, sizeof(name));
				
				if (gConVar_Staff_Join.BoolValue)
					CPrintToChatAll("%t", "Join Message", name);
				if (gConVar_Leave_StaffMode.BoolValue)
					CPrintToChat(client, "%t %t", "Prefix", "Leave Staff Mode");
				
				PickingMenu[client] = false;
			}
			else
			{
				CPrintToChat(client, "%t %t", "Prefix", "You dont have access");
			}
		}
		if (StrEqual(selectedItem, "T"))
		{
			if (GetUserFlagBits(client))
			{
				StaffModes[client] = false;
				
				FakeClientCommand(client, "sm_xlanteespwalljoulax");
				
				ChangeClientTeam(client, CS_TEAM_T);
				
				char name[128];
				GetClientName(client, name, sizeof(name));
				
				if (gConVar_Staff_Join.BoolValue)
					CPrintToChatAll("%t", "Join Message", name);
				if (gConVar_Leave_StaffMode.BoolValue)
					CPrintToChat(client, "%t %t", "Prefix", "Leave Staff Mode");
				
				PickingMenu[client] = false;
			}
			else
			{
				CPrintToChat(client, "%t %t", "Prefix", "You dont have access");
			}
		}
	}
	else if (action == MenuAction_End)
	{
		delete menu;
	}
}


//STEALTH

public Action Command_StealthMode(int client, int args)
{
	if (!client)
		return Plugin_Handled;
	
	if (!g_bHideMe[client])
	{
		g_bHideMe[client] = true;
		
		if (GetClientTeam(client) != CS_TEAM_SPECTATOR && GetConVarInt(sm_stealth_autoswitch) == 1)
			ChangeClientTeam(client, CS_TEAM_SPECTATOR);
	}
	else
		g_bHideMe[client] = false;
	
	return Plugin_Continue;
}

public Action Event_OnPlayerTeam(Handle event, const char[] name, bool dontBroadcast)
{
	int client = GetClientOfUserId(GetEventInt(event, "userid"));
	if (g_bHideMe[client])
	{
		if (g_bHideMe[client] && GetConVarInt(sm_stealth_disable_switch) == 1 && GetConVarInt(sm_stealth_autoswitch) == 1 && GetClientTeam(client) == CS_TEAM_SPECTATOR)
			g_bHideMe[client] = false;
		
		SetEventBroadcast(event, true);
		return Plugin_Changed;
	}
	
	return Plugin_Continue;
}

public void Hook_PMThink(int entity)
{
	for (int i = 1; i <= MaxClients; i++)
	{
		if (IsClientInGame(i) && g_bHideMe[i])
		{
			SetEntData(g_iPlayerManager, g_iAliveOffset + (i * 4), false, 4, true);
			SetEntData(g_iPlayerManager, g_iConnectedOffset + (i * 4), false, 4, true);
			SetEntData(g_iPlayerManager, g_iTeamOffset + (i * 4), 0, 4, true);
			SetEntData(g_iPlayerManager, g_iPingOffset + (i * 4), 0, 4, true);
			SetEntData(g_iPlayerManager, g_iScoreOffset + (i * 4), 0, 4, true);
			SetEntData(g_iPlayerManager, g_iDeathsOffset + (i * 4), 0, 4, true);
			SetEntData(g_iPlayerManager, g_iHealthOffset + (i * 4), 0, 4, true);
		}
	}
}

public void OnGameFrame()
{
	for (int i = 1; i <= MaxClients; i++)
	{
		if (IsClientInGame(i) && g_bHideMe[i])
		{
			SetEntData(g_iPlayerManager, g_iAliveOffset + (i * 4), false, 4, true);
			SetEntData(g_iPlayerManager, g_iConnectedOffset + (i * 4), false, 4, true);
			SetEntData(g_iPlayerManager, g_iTeamOffset + (i * 4), 0, 4, true);
			SetEntData(g_iPlayerManager, g_iPingOffset + (i * 4), 0, 4, true);
			SetEntData(g_iPlayerManager, g_iScoreOffset + (i * 4), 0, 4, true);
			SetEntData(g_iPlayerManager, g_iDeathsOffset + (i * 4), 0, 4, true);
			SetEntData(g_iPlayerManager, g_iHealthOffset + (i * 4), 0, 4, true);
		}
	}
}

//ADMIN ESP

public void OnPluginEnd()
{
	destoryGlows();
}

public void Event_PlayerTeam(Event event, const char[] name, bool dontBroadcast)
{
	int client = GetClientOfUserId(event.GetInt("userid"));
	
	if (client <= 0 || client > MaxClients || !IsClientInGame(client))
	{
		return;
	}
	
	playerTeam[client] = GetClientTeam(client);
}

public void Event_PlayerSpawn(Event event, const char[] name, bool dontBroadcast)
{
	int client = GetClientOfUserId(event.GetInt("userid"));
	
	if (client <= 0 || client > MaxClients || !IsClientInGame(client))
	{
		return;
	}
	
	if (isUsingESP[client])
	{
		if (cLifeState.IntValue != 1)
		{
			canSeeESP[client] = true;
		}
		else
		{
			canSeeESP[client] = false;
		}
	}
	checkGlows();
}

public void Event_PlayerDeath(Event event, const char[] name, bool dontBroadcast)
{
	if (cLifeState.IntValue != 2) {
		
		int client = GetClientOfUserId(event.GetInt("userid"));
		
		if (client > 0 && client <= MaxClients && IsClientInGame(client) && isUsingESP[client])
		{
			canSeeESP[client] = true;
		}
	}
	checkGlows();
}

public void Event_RoundEnd(Event event, const char[] name, bool dontBroadcast)
{
	destoryGlows();
}

public void ConVarChange(ConVar convar, const char[] oldValue, const char[] newValue) {
	for (int i = 0; i <= 1; i++)
	{
		if (convar == cColor[i])
		{
			retrieveColorValue(i);
		}
	}
	checkGlows();
}

public void retrieveColorValue(int index)
{
	char pieces[4][16];
	char color[64];
	cColor[index].GetString(color, sizeof(color));
	if (ExplodeString(color, " ", pieces, sizeof(pieces), sizeof(pieces[])) >= 3)
	{
		for (int j = 0; j < 3; j++)
		{
			colors[index][j] = StringToInt(pieces[j]);
		}
	}
}

public Action Command_ESP(int client, int args)
{
	if (!client || !IsClientInGame(client))
	{
		return Plugin_Handled;
	}
	
	if (args > 0)
	{
		char arg1[32];
		GetCmdArg(1, arg1, sizeof(arg1));
		toggleGlow(client, (StringToInt(arg1) != 0));
	}
	else
	{
		toggleGlow(client, !isUsingESP[client]);
	}
	
	return Plugin_Handled;
}

public void toggleGlow(int client, bool value)
{
	isUsingESP[client] = value;
	
	checkGlows();
}

public void resetPlayerVars(int client)
{
	if (client == 0)
	{
		for (int i = 1; i <= MaxClients; i++)
		{
			resetPlayerVars(i);
		}
		return;
	}
	
	isUsingESP[client] = false;
	playerTeam[client] = 0;
	
	if (IsClientInGame(client))
	{
		playerTeam[client] = GetClientTeam(client);
	}
}

public bool getCanSeeEsp(int client, int lifestate)
{
	switch (lifestate)
	{
		case 1:return !IsPlayerAlive(client);
		case 2:return IsPlayerAlive(client);
	}
	
	return true;
}

public void checkGlows()
{
	playersInESP = 0;
	int lifestate = cLifeState.IntValue;
	
	for (int client = 1; client <= MaxClients; client++)
	{
		if (!IsClientInGame(client) || !isUsingESP[client])
		{
			isUsingESP[client] = false;
			canSeeESP[client] = false;
			continue;
		}
		
		canSeeESP[client] = getCanSeeEsp(client, lifestate);
		
		if (canSeeESP[client])
		{
			playersInESP++;
		}
	}
	
	destoryGlows();
	
	if (playersInESP > 0)
	{
		sv_force_transmit_players.SetString("1", true, false);
		createGlows();
	}
	else
	{
		sv_force_transmit_players.SetString("0", true, false);
	}
}

public void destoryGlows()
{
	for (int client = 1; client <= MaxClients; client++)
	{
		if (IsClientInGame(client))
		{
			RemoveSkin(client);
		}
	}
}

public void createGlows()
{
	char model[PLATFORM_MAX_PATH];
	char attachment[PLATFORM_MAX_PATH];
	int skin = -1;
	int showTeam = cTeam.IntValue;
	int useModel = cModel.IntValue;
	float scale = 1.0;
	
	if (useModel)
	{
		model = HEADPROP;
		attachment = HEADATTACH;
		scale = HEADSCALE;
	}
	else
	{
		attachment = NORMATTACH;
	}
	for (int client = 1; client <= MaxClients; client++)
	{
		if (!IsClientInGame(client) || !IsPlayerAlive(client))
		{
			continue;
		}
		playerTeam[client] = GetClientTeam(client);
		if (playerTeam[client] <= 1)
		{
			continue;
		}
		if (!useModel)
		{
			GetClientModel(client, model, sizeof(model));
		}
		skin = CreatePlayerModelProp(client, model, attachment, !useModel, scale);
		if (skin > MaxClients)
		{
			playerTeam[client] = GetClientTeam(client);
			if (showTeam == 1)
			{
				
				if (playerTeam[client] == 3 && SDKHookEx(skin, SDKHook_SetTransmit, OnSetTransmit_T) || 
					playerTeam[client] == 2 && SDKHookEx(skin, SDKHook_SetTransmit, OnSetTransmit_CT))
				{
					setGlowTeam(skin, playerTeam[client]);
				}
			}
			else if (showTeam == 2) {
				
				if (playerTeam[client] == 2 && SDKHookEx(skin, SDKHook_SetTransmit, OnSetTransmit_T) || 
					playerTeam[client] == 3 && SDKHookEx(skin, SDKHook_SetTransmit, OnSetTransmit_CT))
				{
					setGlowTeam(skin, playerTeam[client]);
				}
			}
			else
			{
				if (SDKHookEx(skin, SDKHook_SetTransmit, OnSetTransmit_All))
				{
					setGlowTeam(skin, playerTeam[client]);
				}
			}
		}
	}
}

public void setGlowTeam(int skin, int team)
{
	if (team >= 2)
	{
		SetupGlow(skin, colors[team - 2]);
	}
}

public Action OnSetTransmit_All(int entity, int client)
{
	if (canSeeESP[client] && playerModelsIndex[client] != entity)
	{
		return Plugin_Continue;
	}
	
	return Plugin_Stop;
}

public Action OnSetTransmit_T(int entity, int client)
{
	if (canSeeESP[client] && playerModelsIndex[client] != entity && playerTeam[client] == 2)
	{
		return Plugin_Continue;
	}
	
	return Plugin_Handled;
}
public Action OnSetTransmit_CT(int entity, int client)
{
	if (canSeeESP[client] && playerModelsIndex[client] != entity && playerTeam[client] == 3)
	{
		return Plugin_Continue;
	}
	
	return Plugin_Handled;
}

public void SetupGlow(int entity, int color[4])
{
	static int offset;
	
	if (!offset && (offset = GetEntSendPropOffs(entity, "m_clrGlow")) == -1)
	{
		LogError("Incapaz de encontrar deslocamento de propriedade: \"m_clrGlow\"!");
		return;
	}
	
	SetEntProp(entity, Prop_Send, "m_bShouldGlow", true);
	SetEntProp(entity, Prop_Send, "m_nGlowStyle", 0);
	SetEntPropFloat(entity, Prop_Send, "m_flGlowMaxDist", 10000.0);
	
	for (int i = 0; i < 3; i++)
	{
		SetEntData(entity, offset + i, color[i], _, true);
	}
}

public int CreatePlayerModelProp(int client, char[] sModel, char[] attachment, bool bonemerge, float scale)
{
	RemoveSkin(client);
	int skin = CreateEntityByName("prop_dynamic_glow");
	DispatchKeyValue(skin, "model", sModel);
	DispatchKeyValue(skin, "solid", "0");
	DispatchKeyValue(skin, "fademindist", "1");
	DispatchKeyValue(skin, "fademaxdist", "1");
	DispatchKeyValue(skin, "fadescale", "2.0");
	SetEntProp(skin, Prop_Send, "m_CollisionGroup", 0);
	DispatchSpawn(skin);
	SetEntityRenderMode(skin, RENDER_GLOW);
	SetEntityRenderColor(skin, 0, 0, 0, 0);
	
	if (bonemerge) {
		SetEntProp(skin, Prop_Send, "m_fEffects", EF_BONEMERGE);
	}
	
	if (scale != 1.0) {
		SetEntPropFloat(skin, Prop_Send, "m_flModelScale", scale);
	}
	
	SetVariantString("!activator");
	AcceptEntityInput(skin, "SetParent", client, skin);
	SetVariantString(attachment);
	AcceptEntityInput(skin, "SetParentAttachment", skin, skin, 0);
	SetVariantString("OnUser1 !self:Kill::0.1:-1");
	AcceptEntityInput(skin, "AddOutput");
	playerModels[client] = EntIndexToEntRef(skin);
	playerModelsIndex[client] = skin;
	
	return skin;
}

public void RemoveSkin(int client)
{
	int index = EntRefToEntIndex(playerModels[client]);
	
	if (index > MaxClients && IsValidEntity(index))
	{
		SetEntProp(index, Prop_Send, "m_bShouldGlow", false);
		AcceptEntityInput(index, "FireUser1");
	}
	
	playerModels[client] = INVALID_ENT_REFERENCE;
	playerModelsIndex[client] = -1;
}

public bool IsValidClient(int client) {
	return (1 <= client && client <= MaxClients && IsClientInGame(client));
}


//COMMAND HIDER

public Action HideCommands(int client, const char[] command, int argc)
{
	if (IsChatTrigger())
		return Plugin_Handled;
	
	return Plugin_Continue;
}

//PICKING TEAM MENU WITH CHAT MESSAGE AND DISABLE WALLHACK

public void Event_OnPlayerTeam1(Event event, const char[] name, bool dontBroadcast)
{
	int client = GetClientOfUserId(GetEventInt(event, "userid"));
	
	if (client == 0 || IsFakeClient(client))
	{
		return;
	}
	
	CreateTimer(0.1, Timer_DelayTeam, GetClientUserId(client), TIMER_FLAG_NO_MAPCHANGE);
}

public Action Timer_DelayTeam(Handle timer, any data)
{
	int client = GetClientOfUserId(data);
	
	if (client == 0 || !PickingMenu[client])
	{
		return Plugin_Continue;
	}
	else if (GetClientTeam(client) == CS_TEAM_CT)
	{
		StaffModes[client] = false;
		
		char name[128];
		GetClientName(client, name, sizeof(name));
		
		if (gConVar_Staff_Join.BoolValue)
			CPrintToChatAll("%t", "Join Message", name);
		if (gConVar_Leave_StaffMode.BoolValue)
			CPrintToChat(client, "%t %t", "Prefix", "Leave Staff Mode");
		
		FakeClientCommand(client, "sm_xlanteespwalljoulax");
		
		PickingMenu[client] = false;
	}
	else if (GetClientTeam(client) == CS_TEAM_T)
	{
		StaffModes[client] = false;
		
		char name[128];
		GetClientName(client, name, sizeof(name));
		
		if (gConVar_Staff_Join.BoolValue)
			CPrintToChatAll("%t", "Join Message", name);
		if (gConVar_Leave_StaffMode.BoolValue)
			CPrintToChat(client, "%t %t", "Prefix", "Leave Staff Mode");
		
		FakeClientCommand(client, "sm_xlanteespwalljoulax");
		
		PickingMenu[client] = false;
	}
	return Plugin_Continue;
}

//JOIN AND LEAVE ANNOUNCER ON CHAT

public Action Event_PlayerConnect5(Event event, const char[] name, bool dontBroadcast)
{
	int userid = GetClientOfUserId(event.GetInt("userid"));
	
	char Name3[MAX_NAME_LENGTH];
	GetClientName(userid, Name3, sizeof(Name3));
	
	if (gConVar_Leave_Message.BoolValue)
		CPrintToChatAll("%t", "Join Message", Name3);
}

public Action Event_PlayerDisconnect5(Event event, const char[] name, bool dontBroadcast)
{
	int userid = GetClientOfUserId(event.GetInt("userid"));
	
	char Name3[MAX_NAME_LENGTH];
	GetClientName(userid, Name3, sizeof(Name3));
	
	if (gConVar_Join_Message.BoolValue)
		CPrintToChatAll("%t", "Leave Message", Name3);
} 